<?php
/**
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; under version 2
 * of the License (non-upgradable).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Copyright (c) 2014 (original work) Open Assessment Technologies SA;
 *
 *
 */

/**
 * Authentication user for key value db access
 *
 * @author christophe massin
 * @package authLdap

 */


namespace oat\authLdap\model;
use common_user_User;
use core_kernel_classes_Resource;
use core_kernel_classes_Property;
use common_Logger;

class LdapUser extends common_user_User {
    
    private $identifier;
    
    private $cache;
    
    public function __construct($id, $data)
    {
        $this->identifier = $id;
        $this->cache = $data;
    }
    
    public function getIdentifier()
    {
        return $this->identifier;
    }
    
    public function getPropertyValues($property)
    {
        return isset($this->cache[$property])
            ? $this->cache[$property]
            : array();
    }
    
    public function refresh() {
        return false;
    }
}
